diff options
author | Jim Meyering <jim@meyering.net> | 2007-03-18 16:21:26 +0100 |
---|---|---|
committer | Jim Meyering <jim@meyering.net> | 2007-03-18 16:21:26 +0100 |
commit | 553d347d3e08e00ee4f9df520b37c964c3f26e28 (patch) | |
tree | 189a05248c9fe5251a5bb5d32887125f19c70783 /tests/misc/pr | |
parent | b1d89070f620c8787a36d93d67b0431ca15fb1dc (diff) | |
download | coreutils-553d347d3e08e00ee4f9df520b37c964c3f26e28.tar.xz |
Fix a bug in how pr -m -s works.
* NEWS: Describe how the fix affects pr.
* src/pr.c (init_parameters): The --merge (-m) option does
not imply --expand-tabs (-e), so don't set "untabify_input".
Reported by Wis Macomson.
* tests/misc/pr: New file. Test for the above fix.
* tests/misc/Makefile.am (TESTS): Add pr.
* THANKS: Update.
Diffstat (limited to 'tests/misc/pr')
-rwxr-xr-x | tests/misc/pr | 61 |
1 files changed, 61 insertions, 0 deletions
diff --git a/tests/misc/pr b/tests/misc/pr new file mode 100755 index 000000000..a40ea31c1 --- /dev/null +++ b/tests/misc/pr @@ -0,0 +1,61 @@ +#!/bin/sh +# -*- perl -*- +# Exercise a bug with pr -m -s + +# Copyright (C) 2007 Free Software Foundation, Inc. + +# This program is free software; you can redistribute it and/or modify +# it under the terms of the GNU General Public License as published by +# the Free Software Foundation; either version 2 of the License, or +# (at your option) any later version. + +# This program is distributed in the hope that it will be useful, +# but WITHOUT ANY WARRANTY; without even the implied warranty of +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the +# GNU General Public License for more details. + +# You should have received a copy of the GNU General Public License +# along with this program; if not, write to the Free Software +# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA +# 02110-1301, USA. + +: ${PERL=perl} +: ${srcdir=.} + +. $srcdir/../envvar-check + +$PERL -e 1 > /dev/null 2>&1 || { + echo 1>&2 "$0: configure didn't find a usable version of Perl," \ + "so can't run this test" + exit 77 +} + +exec $PERL -w -I$srcdir/.. -MCoreutils -- - <<\EOF +#/ +require 5.003; +use strict; + +(my $program_name = $0) =~ s|.*/||; + +$ENV{PROG} = 'pr'; +my $ME = $ENV{PROG}; + +# Turn off localization of executable's ouput. +@ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3; + +my @Tests = + ( + ['merge-w-tabs', '-m -s -t', + {IN=>{1=>"a\tb\tc\n"}}, + {IN=>{2=>"m\tn\to\n"}}, + {IN=>{3=>"x\ty\tz\n"}}, + {OUT=>join("\t", qw(a b c m n o x y z)) . "\n"} ], + ); + +my $save_temps = $ENV{DEBUG}; +my $verbose = $ENV{VERBOSE}; + +my $prog = $ENV{PROG} || die "$0: \$PROG not specified in environment\n"; +my $fail = run_tests ($program_name, $prog, \@Tests, $save_temps, $verbose); +exit $fail; +EOF |